/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.person;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.person.boundary.AbstractPersonendatenDateiExportSearchParameters;
import de.ivu.elect.business.person.boundary.PersonendatenDateiExportChangeEvent;
import de.ivu.elect.business.person.boundary.PersonendatenDateiExportConversationStore;
import de.ivu.elect.business.person.boundary.PersonendatenDateiExportExtendedDAO;
import de.ivu.elect.business.person.boundary.PersonendatenDateiExportSearch;
import de.ivu.elect.business.person.boundary.PersonendatenDateiExportSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.person.entity.PersonendatenDateiExport;
import de.ivu.elect.business.person.entity.PersonendatenDateiExportMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractPersonendatenDateiExportSearchView.COMPONENT_NAME)
@View(viewId = AbstractPersonendatenDateiExportSearchView.VIEW_ID, useCase = UseCasePermission.PERSONENDATEN_DATEI_EXPORT_SEARCH)
public abstract class AbstractPersonendatenDateiExportSearchView extends AbstractElectSearchView<PersonendatenDateiExport> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "personendatenDateiExportSearchView";
  
  public static final String VIEW_ID = "/person/personendaten-datei-export-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractPersonendatenDateiExportSearchView requestHandler;

  @Inject
  private transient PersonendatenDateiExportExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(PersonendatenDateiExportConversationStore.class)
  protected transient PersonendatenDateiExportConversationStore conversationStore;

  @Inject
  protected transient PersonendatenDateiExportSearch search;

  @Inject
  @ConversationGroup(AbstractPersonendatenDateiExportSearchParameters.class)
  protected transient PersonendatenDateiExportSearchParameters searchParameters;

  @Inject
  protected transient PersonendatenDateiExportMeta entityMeta;

  public AbstractPersonendatenDateiExportSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public PersonendatenDateiExport getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(PersonendatenDateiExport entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public PersonendatenDateiExportSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<PersonendatenDateiExport> getEagerLoadingCollector() {
    return EagerLoadingCollector.<PersonendatenDateiExport> create();
  }

  @Override
  public List<PersonendatenDateiExport> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<PersonendatenDateiExport> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onPersonendatenDateiExportChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) PersonendatenDateiExportChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //   Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractPersonendatenDateiExportSearchView {

    @View
    @Inject
    private transient Instance<AbstractPersonendatenDateiExportSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractPersonendatenDateiExportSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
